#!/bin/sh
# the next line restarts using tclsh\
exec tclsh "$0" "$@"

# Port number:
set port 1234

set connected false

set connected_chanID 0 

proc getcommand {} {
	global connected connected_chanID
	if {! [eof $connected_chanID] && [gets $connected_chanID cmd]>0} {
		puts "-> $cmd"
		set answer [string toupper $cmd]
		puts $connected_chanID "$answer\n"
		# - flushes automatically after fconfigure ... -buffering line
		puts "<- $answer sent"
	} else {
		puts "End of file"
		set connected false
	}
}

proc accept { chanID addr port } {
	global connected connected_chanID
	puts "Client connected: chanID = $chanID, port = $port, addr = $addr"
	fconfigure $chanID -buffering line
	puts [fconfigure $chanID]
	set connected true
	set connected_chanID $chanID
	fileevent $chanID readable getcommand
	vwait connected
	if {! $connected} {
		puts "Reset $chanID reading handler"
		fileevent $chanID readable {}
	} else {
		puts "Strange..."
	}
}

proc bkgr {} { after 1200 bkgr; puts \a; after 100; puts \a }

#  Testing connection between Tcl applications: server side that accepts data:
puts "Prepare to accept info in socket port $port..."

set connectchan [ socket -server accept $port ]
puts "Server connection channel=$connectchan"
bkgr
vwait stopvar

puts "Ok, close $connectchan server channel and exit."
close $connectchan
exit
