#!/bin/sh
## Starting the dummy components for SV. Reports PIDs. Creates ./stop_dummies.sh
## which kills those PIDs processes.
# next line restarts using tclsh: \
exec tclsh "$0" "$@"
foreach pr {mass dimm meteo circ} {
	set pid($pr) [exec ./$pr.tcl >&$pr.log &]
}
# Wait until the socket might recognize failure:
set waittime 1
after [expr $waittime*1000]
set fail false
foreach pr {mass dimm meteo circ} {
	if {[catch {exec ps --no-headers --pid $pid($pr)}]} {
		puts "program $pr.tcl is dead. See $pr.log"
		set fail true
	} else {
		puts "$pr.tcl: pid=$pid($pr)"
	}
}
if {$fail} {
	puts "Failed"
} else {
	set sf ./stop_dummies.sh
	exec echo -n "kill" >$sf
	foreach pr {mass dimm meteo circ} {
		exec echo -n " $pid($pr)" >>$sf
	}
	exec echo "\nrm $sf" >>$sf
	exec chmod u+x $sf
	puts "$sf created"
}
